(function(angular, ionic, undefined) {

    angular
        .module('headsup')
        .config(applicationConfigurator);

    applicationConfigurator.$inject = ['$ionicConfigProvider', '$sceDelegateProvider', '$httpProvider', '$configurationProvider', '$geomarkingProvider'];

    function applicationConfigurator($ionicConfigProvider, $sceDelegateProvider, $httpProvider, $configurationProvider, $geomarkingProvider) {

        $ionicConfigProvider.backButton.text('').previousTitleText(false).icon('ion-android-arrow-back');
        $sceDelegateProvider.resourceUrlWhitelist(['self', $configurationProvider.$get().get('serverAddress') + '/**']);
        $httpProvider.defaults.useXDomain = true;
        $geomarkingProvider.googleMapLibraryApi = $configurationProvider.$get().get('googleMapsApiKey');;
        $geomarkingProvider.defaultMapCenterLatitude = $configurationProvider.$get().get('defaultMapSettings').lat;
        $geomarkingProvider.defaultMapCenterLongitude = $configurationProvider.$get().get('defaultMapSettings').lng;
        $geomarkingProvider.defaultGoogleMapZoom = $configurationProvider.$get().get('defaultMapSettings').zoom;
    };

})(angular, ionic);
