(function(angular, ionic, undefined) {

    angular.module('headsup', [
        'ionic',
        'ionic.service.core',
        'ionic.service.push',
        'ngCordova',
        'ngIOS9UIWebViewPatch',
        'ion-datetime-picker',
        'ngFileUpload',
        'ngAnimate',
        'ngMessages',

        'geomarking',
        'remoteFileOpener',

        'headsup.settings',
        'headsup.alerts',
        'headsup.map',
        'headsup.assets',
        'headsup.error',
        'headsup.user'

    ]).run(onApplicationRun);

    onApplicationRun.$inject = ['$ionicPlatform', '$state', '$rootScope', '$configuration', '$pushNotifications', '$deviceManager', '$q', '$userAccount'];

    function onApplicationRun($ionicPlatform, $state, $rootScope, $configuration, $pushNotifications, $deviceManager, $q, $userAccount) {

        $ionicPlatform.ready(function() {

            $rootScope.currentApplication = $configuration.get('app');

            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
            };

            if (window.StatusBar) {
                StatusBar.backgroundColorByHexString($configuration.get('statusBarBgColor'));
            };

            if ($deviceManager.isOnline()) {

                $deviceManager
                    .initiate()
                    .then(function() {

                        if ($configuration.get('pushNotificationsEnabled')) {
                            $pushNotifications.init();
                        };

                        return $q.resolve();
                    })
                    .then(function() {

                        if ($userAccount.isAuthenticated()) {

                            $userAccount
                                .login($userAccount.getSavedUsername(), $userAccount.getSavedPassword())
                                .finally(function() {
                                    $state.go('app.alerts');
                                });
                        } else {
                            $state.go('app.alerts');
                        };
                    });

            } else {
                $state.go('error.no-network');
            };

        });
    };


})(angular, ionic)