(function(angular, ionic, undefined) {

    angular
        .module('headsup')
        .directive('flashMessages', flashMessages);

    flashMessages.$inject = ['$rootScope', '$ionicScrollDelegate'];

    function flashMessages($rootScope, $ionicScrollDelegate) {

        var directive = {
            restrict: 'E',
            scope: {},
            link: link
        };

        return directive;

        function link(scope, element) {
            $rootScope.$on('user:flash:success', addSuccessFlash);
            $rootScope.$on('user:flash:error', addErrorFlash);

            function addSuccessFlash(event, message) {
                var
                    message = angular.element('<div class="alert alert-success"></div>').text(message);

                element.append(message);

                setTimeout(function() {
                    message.addClass('hide');

                    setTimeout(function() {
                        message.remove();
                    }, 300);
                }, 10000);

                $ionicScrollDelegate.scrollTop(true);
            };

            function addErrorFlash(event, message) {
                var
                    message = angular.element('<div class="alert alert-danger"></div>').text(message);

                element.append(message);

                setTimeout(function() {
                    message.addClass('hide');

                    setTimeout(function() {
                        message.remove();
                    }, 300);
                }, 10000);

                $ionicScrollDelegate.scrollTop(true);
            };
        };
    };

})(angular, ionic);




