(function(angular, ionic, undefined) {

    angular
        .module('headsup')
        .directive('repeatedControl', repeatedControl);

    repeatedControl.$inject = ['$compile', '$ionicScrollDelegate'];

    function repeatedControl($compile, $ionicScrollDelegate) {

        var directive = {
            templateUrl: "app/directives/repeated-control/repeated-control.directive.html",
            transclude: true,
            restrict: 'E',
            scope: {
                ngModel: '=',
                form: '=',
                placeholder: '=?',
                label: '='
            },
            link: link
        };

        return directive;

        function link(scope, element, attrs, ctrl, transclude) {

            if (!scope.ngModel) {
                scope.ngModel = [];
            };

            scope.add = add;

            function add() {
                scope.ngModel.push('');
            };

            scope.$watch('ngModel.length', render);

            render();

            function render() {

                var
                    container = element.find('repeated-controls');

                    container.empty();

                for (var i = 0; i < scope.ngModel.length; i++) {


                    var
                        childScope = scope.$new(false, scope),
                        item = scope.form ? angular.element('<ng-form name="repeatedControlInnerForm"></ng-form>') : angular.element('<div></div>');

                    childScope.value = scope.ngModel[i];
                    childScope.updateValue = function(index, $event) {

                        if (undefined !== scope.ngModel[index] && $event) {
                            scope.ngModel[index] = angular.element($event.currentTarget).val();
                        };
                    };

                    transclude(scope.$parent, function(clone) {

                        item.append(angular.element('<div></div>').append(clone));

                        var
                            input = item.find('textarea');

                        if (input.length == 0) {
                            input = item.find('input');
                        };

                        input.attr('name', 'innerControl');
                        input.attr('ng-keyup', 'updateValue(' + i + ', $event)');

                        if (scope.form) {
                            childScope.form = scope.form;
                            item.attr('ng-class', '{\'has-errors\' : repeatedControlInnerForm.innerControl.$invalid && form.$submitted, \'no-errors\' : repeatedControlInnerForm.innerControl.$valid && form.$submitted }');
                        };

                        input.attr('required', 'required');
                        input.attr('ng-model', 'value');
                    });

                    childScope.remove = function(i) {
                        scope.ngModel.splice(i, 1);
                    };

                    item.append('<i class="ion-close-circled" ng-click="remove(' + i + ')"></i>')

                    container.append($compile(item)(childScope));
                };

                $ionicScrollDelegate.resize();
            };
        };
    };

})(angular, ionic);




