(function(angular, ionic, undefined) {

    angular
        .module('headsup')
        .directive('slidingPanel', slidingPanel);

    slidingPanel.$inject = ['$ionicScrollDelegate'];

    function slidingPanel($ionicScrollDelegate) {

        var directive = {
            templateUrl: "app/directives/sliding-panel/sliding-panel.directive.html",
            restrict: 'E',
            transclude: true,
            scope: {
                titleOpen: '=?',
                titleClose: '=?',
                closed: '=?'
            },
            link: link
        };

        return directive;

        function link(scope, element) {

            var
                contentPanel = element.find('> div.sliding-panel > div.sliding-panel-content');

            if (undefined === scope.titleOpen) {
                scope.titleOpen = 'More';
            };

            if (undefined === scope.titleClose) {
                scope.titleClose = 'Less';
            };

            if (undefined === scope.closed) {
                scope.closed = true;
            };

            scope.$watch('closed', function() {

                if (scope.closed) {

                    contentPanel.slideUp(function() {
                        $ionicScrollDelegate.resize();
                    });
                } else {

                    contentPanel.slideDown(function() {
                        $ionicScrollDelegate.resize();
                    });
                };
            });
        };
    };

})(angular, ionic);



