(function(angular, ionic, undefined) {

    angular
        .module('headsup')
        .filter('location_label', locationLabel)
    ;

    locationLabel.$inject = ['$locations'];

    function locationLabel($locations) {

        return function (ids) {

            if (ids) {

                if (undefined === ids.length) {
                    ids = [ids];
                };

                var
                    labels = [];

                angular.forEach(ids, function(id) {

                    var
                        label = $locations.label(id);

                    if (label) {
                        labels.push(label);
                    };
                });

                if (labels.length > 0) {
                    return labels.join(', ');
                };
            };

            return '-';
        };
    };


})(angular, ionic);


