(function(angular, ionic, undefined) {

    angular
        .module('headsup')
        .service('$categories', Categories);

    function Categories() {

        var
            categories = [],
            flattened = [],
            ids = [],
            count = 0;

        this.setAll = setAll;
        this.getAll = getAll;
        this.ids = getIds;
        this.icon = icon;
        this.marker = marker;
        this.label = label;
        this.count = getCount;

        function setAll(arg) {
            categories = arg;
            flattened = [];
            ids = [];

            function flattenSubcategory(category) {
                flattened[parseInt(category.id)] = category;
                ids.push(category.id);

                if (category.children && category.children.length > 0) {
                    angular.forEach(category.children, flattenSubcategory);
                } else {
                    count++;
                };
            };

            angular.forEach(categories, flattenSubcategory);

            return this;
        };

        function getAll() {
            return categories;
        };

        function getIds() {
            return ids;
        };

        function icon(id) {

            var
                category = flattened[parseInt(id)];

            if (undefined !== category) {
                return category.icon;
            } else {
                return '';
            };
        };

        function marker(id) {

            var
                category = flattened[parseInt(id)];

            if (undefined !== category) {
                return category.marker;
            } else {
                return '';
            };
        };

        function label(id) {

            var
                category = flattened[parseInt(id)];

            if (undefined !== category) {
                return category.name;
            } else {
                return '';
            };
        };

        function getCount() {
            return count;
        };

    };

})(angular, ionic);
