(function(angular, ionic, applicationConfiguration, undefined) {

    angular
        .module('headsup')
        .service('$configuration', Configuration)
        .provider('$configuration', ConfigurationServiceProvider);

    function Configuration() {

        var
            self = this,
            configuration = applicationConfiguration;

        this.get = function(key, defaultValue) {

            if (configuration.hasOwnProperty(key)) {
                return configuration[key];
            };

            return defaultValue;
        };

        this.set = function(key, value) {
            configuration[key] = value;
            return self;
        };
    };

    function ConfigurationServiceProvider() {

        this.$get = function() {
            return new Configuration();
        };
    };

})(angular, ionic, applicationConfiguration);
