(function(angular, ionic, undefined) {

    angular
        .module('headsup')
        .service('$locations', Locations);

    function Locations() {

        var
            locations = [],
            flattened = [],
            ids = [],
            count = 0;

        this.setAll = setAll;
        this.getAll = getAll;
        this.ids = getIds;
        this.icon = icon;
        this.label = label;
        this.count = getCount;

        function setAll(arg) {
            locations = arg;
            flattened = [];
            ids = [];

            function flattenSublocation(location) {
                flattened[parseInt(location.id)] = location;
                ids.push(location.id);

                if (location.children && location.children.length > 0) {
                    angular.forEach(location.children, flattenSublocation);
                } else {
                    count++;
                };
            };

            angular.forEach(locations, flattenSublocation);

            return this;
        };

        function getAll() {
            return locations;
        };

        function getIds() {
            return ids;
        };

        function icon(id) {

            var
                location = flattened[parseInt(id)];

            if (undefined !== location) {
                return location.icon;
            } else {
                return '';
            };
        };

        function label(id) {

            var
                location = flattened[parseInt(id)];

            if (undefined !== location) {
                return location.name;
            } else {
                return '';
            };
        };

        function getCount() {
            return count;
        };
    };

})(angular, ionic);
