(function(angular, ionic, undefined) {

    angular.module('headsup.controllers.assets', [])

        .controller('ShowAssetController', ['$stateParams', '$scope', '$deviceManager', '$cordovaSocialSharing', '$remoteFileOpener', '$q', function($stateParams, $scope, $deviceManager, $cordovaSocialSharing, $remoteFileOpener, $q) {

            $scope.share = function(title, url) {
                $cordovaSocialSharing.share(title, 'Heads Up', null, url);
            };

            $scope.open = function($event, url, mime) {

                $scope.loadingSpinner = true;

                var
                    button = angular.element($event.currentTarget);

                $remoteFileOpener
                    .has(url)
                    .then(function(has) {

                        var
                            deferred = $q.defer();

                        if (has) {
                            deferred.resolve();
                            $scope.loadingSpinner = false;
                        } else {
                            $remoteFileOpener
                                .download(url)
                                .then(function() {
                                    deferred.resolve();
                                })
                                .catch(function() {
                                    deferred.reject();
                                })
                                .finally(function() {
                                    $scope.loadingSpinner = false;
                                });
                        }

                        return deferred.promise;
                    })
                    .then(function() {
                        return $remoteFileOpener.open(url, mime);
                    })
                    .catch(function() {
                        $deviceManager.alert('Sorry, it seams that requested file could not be opened on this device....');

                        button
                            .removeClass('button-balanced')
                            .removeClass('ion-ios-cloud-download')
                            .addClass('button-assertive')
                            .addClass('disabled')
                            .addClass('ion-close')
                            .prop('disabled', 'true')
                        ;
                    });
            };

            $scope.$on('$ionicView.enter', function() {

                $scope.url = $stateParams.url;
                $scope.mime = $stateParams.mime;
                $scope.title = $stateParams.title;

                switch ($stateParams.mime) {
                    case 'image/jpg':       // FALL TROUGH !!!
                    case 'image/jpeg':      // FALL TROUGH !!!
                    case 'image/gif':       // FALL TROUGH !!!
                    case 'image/png':
                        $scope.img = $stateParams.url;
                        break;
                    default:
                        /* noop */
                        break;
                };
            });

        }])
    ;

})(angular, ionic);
