(function(angular, ionic, undefined) {

    angular
        .module('headsup.alerts')
        .directive('alertFilesUpload', alertFilesUpload);

    alertFilesUpload.$inject = ['$filter'];

    var
        globalCounter = 0;

    function alertFilesUpload($filter) {

        var directive = {
            templateUrl: "modules/alerts/directives/alert-files-upload/alert-files-upload.directive.html",
            restrict: 'E',
            scope: {
                ngModel: '=',
                label: '=?',
                btnAddLabel: '=?',
                maxNbFiles: '=?',
                fileTypes: '=?',
                placeholder: '=?',
                form: '='
            },
            link: link
        };

        return directive;

        function link(scope, element, attrs) {

            if (!scope.maxNbFiles) {
                scope.maxNbFiles = 100;
            };

            if (!scope.fileTypes) {
                scope.fileTypes = [];
            };

            scope.selectFiles = selectFile;
            scope.removeFile = removeFile;

            angular.forEach(scope.ngModel, function(file){
                file.extension = $filter('extension_from_mime')(file.mime);
            });

            function selectFile(files) {

                for (var i = 0; i < files.length; i++) {

                    if (scope.ngModel.length >= scope.maxNbFiles) {
                        break;
                    };

                    scope.ngModel.push({
                        id: null,
                        description: files[i].name.substr(0, files[i].name.lastIndexOf('.')),
                        extension: $filter('extension_from_mime')(files[i].type),
                        filename: files[i].name,
                        src: files[i],
                        data: null
                    });
                };
            };

            function removeFile(image) {

                var
                    index = scope.ngModel.indexOf(image);

                if (index > -1) {
                    scope.ngModel.splice(index, 1);
                };
            };
        };
    };

})(angular, ionic);
