(function(angular, ionic, undefined) {

    angular
        .module('headsup.alerts')
        .directive('alertImagesUpload', alertImagesUpload);

    function alertImagesUpload() {

        var directive = {
            templateUrl: "modules/alerts/directives/alert-images-upload/alert-images-upload.directive.html",
            restrict: 'E',
            scope: {
                ngModel: '=',
                label: '=?',
                btnAddLabel: '=?',
                maxNbFiles: '=?',
                fileTypes: '=?'
            },
            link: link
        };

        return directive;

        function link(scope, element, attrs) {

            if (!scope.maxNbFiles) {
                scope.maxNbFiles = 100;
            };

            if (!scope.fileTypes) {
                scope.fileTypes = ['image/jpg', 'image/jpeg', 'image/png', 'image/gif'];
            };

            scope.processing = false;

            scope.selectImages = selectImages;
            scope.removeImage = removeImage;

            scope.startProcessing = function() {
                scope.processing = true;
            };

            function selectImages(images) {

                for (var i = 0; i < images.length; i++) {

                    if (scope.ngModel.length >= scope.maxNbFiles) {
                        break;
                    };

                    scope.ngModel.push({
                        id: null,
                        src: images[i],
                        data: null,
                        filename: images[i].name
                    });
                };

                scope.processing = false;
            };

            function removeImage(image) {

                var
                    index = scope.ngModel.indexOf(image);

                if (index > -1) {
                    scope.ngModel.splice(index, 1);
                };
            };
        };
    };

})(angular, ionic);
