(function(angular, ionic, undefined) {

    angular
        .module('headsup.alerts')
        .directive('eventOnsetValidator', eventOnsetValidator)
    ;

    function eventOnsetValidator($parse) {

        var directive = {
            restrict: 'A',
            require: 'ngModel',
            scope: {
                eventExpires: '='
            },
            link: link
        };

        return directive;

        function link(scope, elm, attrs, ctrl) {

            ctrl.$error = {
                eventOnsetAfterEventExpires : false,
                eventOnsetMustBeDefinedIfExpiresIsDefined: false
            };

            scope.$watch('eventExpires', function() {
                ctrl.$validate();
            });

            ctrl.$validators.eventOnsetValidator = function(modelValue) {

                ctrl.$error = {
                    eventOnsetAfterEventExpires : false,
                    eventOnsetMustBeDefinedIfExpiresIsDefined: false
                };

                if (null !== modelValue && null !== scope.eventExpires && modelValue > scope.eventExpires) {
                    ctrl.$error.eventOnsetAfterEventExpires = true;
                    return false;
                };

                if (null === modelValue && null !== scope.eventExpires) {
                    ctrl.$error.eventOnsetMustBeDefinedIfExpiresIsDefined = true;
                    return false;
                };

                return true;
            };
        };
    };

})(angular, ionic);



