(function(angular, ionic, undefined) {

    angular
        .module('headsup.alerts')
        .config(routeConfigurator);

    routeConfigurator.$inject = ['$stateProvider'];

    function routeConfigurator($stateProvider) {

        $stateProvider
            .state('app.maps', {
                url: '/maps',
                cache: true,
                views: {
                    'menuContent': {
                        templateUrl: 'modules/map/view/map.html',
                        controller: 'ShowAlertsMapController as vm'
                    }
                },
                resolve: {
                    initialize: ['$deviceManager', '$q', '$geomarking', function ($deviceManager, $q, $geomarking) {

                        var
                            deferred = $q.defer();

                        $deviceManager
                            .initiate()
                            .then(function() {
                                return $geomarking.loadGoogleMapLibrary();
                            })
                            .then(function() {
                                deferred.resolve();
                            });

                        return deferred.promise;
                    }]
                }
            })
        ;

    };

})(angular, ionic);


