(function(angular, ionic, undefined) {

    angular
        .module('headsup.user')
        .controller('LoginController', LoginController);

    LoginController.$inject = ['$ionicHistory', '$userAccount', '$state', '$deviceManager', '$controller', '$scope'];

    function LoginController($ionicHistory, $userAccount, $state, $deviceManager, $controller, $scope) {

        angular.extend(this, $controller('PushedAlertAbstractController', { $scope: $scope, options: { withPopup: true }}));

        var vm = this;

        vm.credentials = {
            username: $userAccount.getSavedUsername(),
            password:  $userAccount.getSavedPassword()
        };

        vm.error = false;
        vm.loadingSpinner = false;

        vm.login = login;

        function login (form) {

            vm.error = false;

            if (form.$valid) {

                vm.loadingSpinner = true;

                $userAccount.login(vm.credentials.username, vm.credentials.password)
                    .then(function() {

                        $deviceManager.alert('You have been successfully logged in.');

                        $ionicHistory.nextViewOptions({
                            disableBack: true
                        });

                        $state.go('app.myAlerts', {}, { reload: true });
                    })
                    .catch(function(reason) {
                        if (reason.status = 401) {
                            vm.error = reason.reason.data.message;
                        } else {
                            throw 'Fatal error, could not execute login.';
                        };
                    })
                    .finally(function(){
                        vm.loadingSpinner = false;
                    });
                ;
            };
        };
    };

})(angular, ionic);
